//
//  ContentView.swift
//  test-activity-indicator
//
//  Created by Huy Trinh Duc on 15/05/2023.
//

import SwiftUI

struct ContentView: View {
    
    @StateObject private var viewModel = ViewModel()
    
    var body: some View {
        VStack {
            TextField("Enter username", text: $viewModel.username)
                .textFieldStyle(RoundedBorderTextFieldStyle())
            TextField("Enter password", text: $viewModel.password)
                .textFieldStyle(RoundedBorderTextFieldStyle())
            
            Spacer().frame(height: 30)
            
            Button {
                viewModel.triggerLogin()
            } label: {
                Text("Login")
            }
            .disabled(!viewModel.isEnableLoginButton)
            
            Spacer()
        }
//        .onReceive(viewModel.errorPublisher, perform: { error in
//            print("error by track \(error.localizedDescription)")
//        })
        .onReceive(viewModel.$errorCatchPublisher, perform: { error in
            print("error by catch \(error?.localizedDescription ?? "no error")" )
        })
        .padding()
    }
}

struct ContentView_Previews: PreviewProvider {
    static var previews: some View {
        ContentView()
    }
}
